﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CFScript
{
    public class ScriptResult
    {
        ResultCode code;
        List<InstructionResult> executedInstructions;
        string message;

        public ResultCode Code
        {
            get { return this.code; }
            set { this.code = value; }
        }

        public List<InstructionResult> InstructionResults
        {
            get { return this.executedInstructions; }
            set { this.executedInstructions = value; }
        }

        public string Message
        {
            get { return this.message; }
            set { this.message = value; }
        }

        public ScriptResult()
        {
            this.code = ResultCode.OK;
            this.executedInstructions = new List<InstructionResult>();
        }
    }
}
